# Text File Viewer Module

## Overview
The Text File Viewer module allows you to display and syntax-highlight text files directly in Drupal. It integrates with Prism.js to provide a customizable and efficient syntax-highlighting solution for various file types.

## Features
- Supports syntax highlighting for multiple file extensions.
- Configurable display options to control formatting and appearance.
- Local or external library support for flexibility.

## Requirements
- Drupal 10.x 
- PHP 8.1 or higher
- Prism.js library (can be used locally or from an external source)

## Installation
1. Download and install the module in your Drupal installation:
   ```bash
   composer require drupal/text_file_viewer
   ```
2. Enable the module via the Drupal UI or Drush:
   ```bash
   drush en text_file_viewer
   ```

## Using a Local Library
1. Download the required JavaScript and CSS library from [Prism.js](https://prismjs.com/download.html#themes=prism&languages=markup+css+clike+javascript):
   - Select all file extensions you want to enable syntax highlighting for on your site.
2. Move the downloaded `prism.js` and `prism.css` files to the following directory in your module's folder:
   ```
   text_file_formatter/libraries/
   ```
3. Navigate to **Text File Formatter Configurations** in the Drupal admin interface.
4. Locate the **External Library Location Setting**.
5. Select the **Local** radio option to use the locally downloaded library.
6. Restrict the file extensions in the module configuration to match the extensions selected during the library download.

## Configuration
1. Navigate to the **Manage Display** tab of the content type that includes the text file field.
2. Select the "Text File Viewer" formatter for the desired file field.
3. Adjust additional configuration options, such as syntax-highlighting themes or supported extensions.

## Usage
Once configured, the module will render text files uploaded to the specified fields with syntax highlighting using the Prism.js library.

## Contributing
Contributions are welcome! Feel free to open issues or submit pull requests to enhance the functionality of this module.

## License
This project is licensed under the GPL-2.0-or-later license. See the LICENSE file for details.

